#!/usr/bin/perl

#  The license of this code is LGPL. See license.LGPL


use strict;

my $ticks_per_sec=0;

my $re_ticks_per_sec = "# TICKS_PER_SEC";

my %datahash=();

while(<STDIN>) {
  chomp;
  if( /$re_ticks_per_sec=([0-9]+)/ ) {
    $ticks_per_sec = $1;
  } elsif ( /([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)/ ) {
    push @{ $datahash{$1}->{randomread}->{data} }, $2;
    push @{ $datahash{$1}->{randomcopy}->{data} }, $3;
    push @{ $datahash{$1}->{streamcopy}->{data} }, $4;
  }
}

my $ticks_per_usec = $ticks_per_sec/1000.0/1000.0;
my $ticks_per_nsec = $ticks_per_sec/1000.0/1000.0/1000.0;

foreach my $iter ( sort keys %datahash ) {
  printf "%8d " , $iter ;
  foreach my $method ( keys %{ $datahash{$iter} } ) {
    #print "m=$method ";

    $datahash{$iter}->{$method}->{mean} = 0.0;
    $datahash{$iter}->{$method}->{sd} = 0.0;
    $datahash{$iter}->{$method}->{n} = 0;

    foreach my $v ( @{ $datahash{$iter}->{$method}->{data} } ) {
      my $t = $v/$iter/$ticks_per_nsec;  # nsec/iteration
      $datahash{$iter}->{$method}->{mean} += $t;
      $datahash{$iter}->{$method}->{n} ++;
    }
    $datahash{$iter}->{$method}->{mean} /= $datahash{$iter}->{$method}->{n};

    foreach my $v ( @{ $datahash{$iter}->{$method}->{data} } ) {
      my $t = $v/$iter/$ticks_per_nsec;  # nsec/iteration
      my $tt = $t-$datahash{$iter}->{$method}->{mean};
      $datahash{$iter}->{$method}->{sd} += ($tt*$tt);
    }
    $datahash{$iter}->{$method}->{sd} /= $datahash{$iter}->{$method}->{n};
    $datahash{$iter}->{$method}->{sd} = sqrt($datahash{$iter}->{$method}->{sd});

    printf "%e", $datahash{$iter}->{$method}->{mean};
    print " ";
    printf "%e", $datahash{$iter}->{$method}->{sd}; 
    print "  ";
  }
  print "\n";
}
