#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>

int  get_hugepage_size()
{
  char buf[1024];
  int  hugepage_size=0;

  char *keyword = "Hugepagesize:";
  FILE* fp = fopen("/proc/meminfo", "r");
  if( !fp ) {
    perror("fopen");
    exit(1);
  }
  while(fgets(buf, sizeof(buf), fp ) != (char*)NULL ) {
    if( strncmp( buf, keyword, strlen(keyword) ) == 0 ) {
      char* p=buf;
      while( *p && (!isdigit(*p)) ) p++;
      hugepage_size = atoi(p);
      break;
    }
  }

  fclose(fp);
  return hugepage_size*1024;
}


unsigned long long get_cpufreq_HZ()
{
  char buf[1024];
  double freq=0.0;

  if( access("/proc/personality.sh", R_OK) == 0 ) {
    /* we guess this is BG/L, so freq is fixed */
    return 700*1000*1000;
  }

  FILE* fp = fopen("/proc/cpuinfo", "r");
  if( !fp ) {
    perror("fopen");
    exit(1);
  }
  while(fgets(buf, sizeof(buf), fp ) != (char*)NULL ) {
    if( strncmp( buf, "cpu MHz", 7 ) == 0 ) {
      char* p;
      p = buf;
      while( *p && (!isdigit(*p)) ) p++;
      freq = atof(p);
      break;
    }
  }

  fclose(fp);

  return (unsigned long long)(freq*1000*1000);
}

