#ifndef __MEMBENCH_KERNEL_H_DEFINED
#define __MEMBENCH_KERNEL_H_DEFINED

#if HAS_LONGLONG
typedef struct {
  unsigned long long val;
} tick_t;
#define TICK_UINT64(a)    (a.val)
#else
typedef struct {
  unsigned long high;
  unsigned long low;
} tick_t;
#define TICK_UINT64(a)    (((unsigned long long)a.high<<32)|a.low)
#endif

/* 8 bytes per iteration */
tick_t method_randomread( void* ptr, unsigned size, int niter );
tick_t method_randomcopy( void* ptr, unsigned size, int niter );
tick_t method_streamcopy( void* ptr, unsigned size, int niter );

#ifdef DATATYPE_NAME
const char* datatypeid_name();
#endif


#endif
