#!/bin/sh

if [ ! -x bench_regular ] ; then
    make
fi

mount|grep -q /mnt/huge
if [ "$?" != "0" ] ; then
    echo "Please run ./mount_hugetlb.sh with root privilege!"
    exit 1
fi

EXTSTR=""
if [ ! -z "$1" ] ; then
    EXTSTR="-$1"
fi


HPAGESIZE_MB=`perl -ne 'if(/^Hugepagesize:\s+([0-9]+)/) { print $1/1024, "\n";}' < /proc/meminfo`

VER=`uname -r`

for mb in 64 128 ; do
    bytes=`expr $mb \* 1024 \* 1024`
    nhugepages=`expr $mb / $HPAGESIZE_MB`

    export MEMLATENCY_BENCH_BUFSIZE=$bytes

    echo "BUFSIZE=${mb}MB"  
    echo "  testing hugetlb ..."
    echo "  requesting $nhugepages huge pages"
    echo $nhugepages > /proc/sys/vm/nr_hugepages
    ./bench_hugetlb > res-$VER-${mb}MB$EXTSTR-huge.dat
    echo "  testing regular ..."
    echo 0 > /proc/sys/vm/nr_hugepages
    ./bench_regular > res-$VER-${mb}MB$EXTSTR-regular.dat
    unset MEMLATENCY_BENCH_BUFSIZE
done

echo "done"

exit 0
